zoj 3706 Break Standard Weight(dp)

Break Standard Weight

Time Limit: 2 Seconds                                     Memory Limit: 65536 KB                            

The balance was the first mass measuring instrument invented. In its traditional form, it consists of a pivoted horizontal lever of equal length arms, called the beam, with a weighing pan, also called scale, suspended from each arm (which is the origin of the originally plural term "scales" for a weighing instrument). The unknown mass is placed in one pan, and standard masses are added to this or the other pan until the beam is as close to equilibrium as possible. The standard weights used with balances are usually labeled in mass units, which are positive integers.

With some standard weights, we can measure several special masses object exactly, whose weight are also positive integers in mass units. For example, with two standard weights 1 and 5, we can measure the object with mass 1, 4, 5 or 6 exactly.

In the beginning of this problem, there are 2 standard weights, which masses are x and y. You have to choose a standard weight to break it into 2 parts, whose weights are also positive integers in mass units. We assume that there is no mass lost. For example, the origin standard weights are 4 and 9, if you break the second one into 4 and 5, you could measure 7 special masses, which are 1, 3, 4, 5, 8, 9, 13. While if you break the first one into 1 and 3, you could measure 13 special masses, which are 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13! Your task is to find out the maximum number of possible special masses.

Input

There are multiple test cases. The first line of input is an integer T < 500 indicating the number of test cases. Each test case contains 2 integers x and y. 2  ≤ x, y  ≤ 100

Output

For each test case, output the maximum number of possible special masses.

Sample Input
2
4 9
10 10
Sample Output
13
9

                            Author: YU, Zhi                                                     Contest: The 10th Zhejiang Provincial Collegiate Programming Contest

 

 

题意:两个砝码,将其中一个拆分后,得到三个数字,问这三个数字通过加减能组合成多少个数字
思路:1、首先是得到这三个数,怎么得到呢?假设两个砝码为x,y,可以分别把x、y进行分解,分解成两部分,可以x/2,y/2来枚举,并且要从小到大排序 然后标记,以免重复计算
2、然后是进行计算个数。dp[i][j]表示在第i个数时,j是否可以通过三个数字组合而成,dp[i][j]=1表示可以组合成j这个数字
3、然后枚举sum,for(int j=sum;j>=1;j--)进行判断,如果j>=当前的数字tmp,那么if(dp[i-1][j-tmp]==1)(j-tmp表示可以组成),能组成j-tmp的话,那么加上tmp也是可以的,所以dp[i][j]=1;
如果dp[i-1][j]==1,即能组成j的话,那么dp[i][j-tmp]=1,即j-w也是可以组成的
如果j<tmp,那么当 dp[i-1][j]=1 ,即j能组成的话,dp[i-1][tmp-j]=1 即j-w也能组成
然后统计所以得情况即可
 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstring>
 4 #include<algorithm>
 5 #include<vector>
 6 using namespace std;
 7 #define N 106
 8 int vis[N][N][N];
 9 int m[6];
10 int ans;
11 int dp[16][N<<1];
12 int sum;
13 bool cmp(int a,int b)
14 {
15     return a>b;
16 }
17 void solve()
18 {
19     memset(dp,0,sizeof(dp));
20     dp[0][0]=1;
21     for(int i=1;i<=3;i++)
22     {
23         int tmp=m[i];
24         memcpy(dp[i],dp[i-1],sizeof(dp[0]));
25         for(int j=sum;j>=1;j--)
26         {
27             if(j>=tmp)
28             {
29                 if(dp[i-1][j-tmp])
30                   dp[i][j]=1;
31                 if(dp[i-1][j])
32                   dp[i][j-tmp]=1;
33             }
34             else 
35             {
36                 if(dp[i-1][j])
37                   dp[i-1][tmp-j]=1;
38             }
39         }
40     }
41     int cnt=0;
42     for(int i=1;i<=sum;i++)
43       if(dp[3][i]==1)
44         cnt++;
45     if(ans<cnt)
46      ans=cnt;
47 }
48 int main()
49 {
50     int t;
51     scanf("%d",&t);
52     while(t--)
53     {
54         int x,y;
55         sum=0;
56         scanf("%d%d",&x,&y);
57         sum=x+y;
58         ans=0;
59         memset(vis,0,sizeof(vis));
60         m[0]=10000000;
61         for(int i=1;i<=x/2;i++)
62         {
63             m[1]=i;
64             m[2]=x-i;
65             m[3]=y;
66             sort(m,m+1+3,cmp);
67             if(!vis[m[1]][m[2]][m[3]])
68             {
69                 vis[m[1]][m[2]][m[3]]=1;
70                 solve();
71             }
72             
73         }
74         for(int i=1;i<=y/2;i++)
75         {
76             m[1]=i;
77             m[2]=y-i;
78             m[3]=x;
79             sort(m,m+1+3,cmp);
80             if(!vis[m[1]][m[2]][m[3]])
81             {
82                 vis[m[1]][m[2]][m[3]]=1;
83                 solve();
84             }
85         }
86         printf("%d\n",ans);
87     }
88     return 0;
89 }
View Code

 

转载于:https://www.cnblogs.com/UniqueColor/p/4741160.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值